<table
  mat-table
  multiTemplateDataRows
  [dataSource]="testCaseDataSource"
  matSort
  class="execution-test-case-table border-grey-300 mt-1"
  aria-label="Test-cases execution table"
>
  <ng-container matColumnDef="name">
    <th
      mat-header-cell
      *matHeaderCellDef
      mat-sort-header
      sortActionDescription="Sort by Test Case name"
    >
      Test Case
    </th>
    <td mat-cell *matCellDef="let testCase">
      {{ testCase.name }}
    </td>
  </ng-container>

  <ng-container matColumnDef="testSuiteDescription">
    <th
      mat-header-cell
      *matHeaderCellDef
      mat-sort-header
      sortActionDescription="Sort by Test Suite"
    >
      Test suite
    </th>
    <td mat-cell *matCellDef="let testCase">
      {{ testCase.testSuiteDescription }}
    </td>
  </ng-container>

  <ng-container matColumnDef="testSuiteLastUpdate">
    <th
      mat-header-cell
      *matHeaderCellDef
      mat-sort-header
      sortActionDescription="Sort by Test Suite last update"
    >
      Suite last update
    </th>
    <td mat-cell *matCellDef="let testCase">
      {{ testCase.testSuiteLastUpdate | date: "dd/M/yyyy" }}
    </td>
  </ng-container>

  <ng-container matColumnDef="description">
    <th
      mat-header-cell
      *matHeaderCellDef
      mat-sort-header
      sortActionDescription="Sort by Description"
    >
      Description
    </th>
    <td mat-cell *matCellDef="let testCase">
      {{ testCase.description }}
    </td>
  </ng-container>

  <ng-container matColumnDef="startDate">
    <th
      mat-header-cell
      *matHeaderCellDef
      mat-sort-header
      sortActionDescription="Sort by Start date"
    >
      Start time
    </th>
    <td mat-cell *matCellDef="let testCase">
      {{ testCase.startDate | date: "dd/M/yyyy" }}
    </td>
  </ng-container>

  <ng-container matColumnDef="endDate">
    <th
      mat-header-cell
      *matHeaderCellDef
      mat-sort-header
      sortActionDescription="Sort by End date"
    >
      End time
    </th>
    <td mat-cell *matCellDef="let testCase">
      {{
        testCase.endDate
          ? (testCase.endDate.toString() | date: "dd/M/yyyy")
          : "/"
      }}
    </td>
  </ng-container>

  <ng-container matColumnDef="status">
    <th
      mat-header-cell
      *matHeaderCellDef
      mat-sort-header
      sortActionDescription="Sort by status"
    >
      Status
    </th>
    <td mat-cell *matCellDef="let testCase">
      <div class="slabs-comp ec-chips-theme">
        <mat-chip
          highlighted
          class="slabs-chip"
          [color]="status2ChipColor.get(testCase.status.toUpperCase())"
        >
          {{ testCase.status }}
        </mat-chip>
      </div>
    </td>
  </ng-container>

  <ng-container matColumnDef="logs">
    <th mat-header-cell *matHeaderCellDef>Logs</th>
    <td mat-cell *matCellDef="let testCase">
      <mat-icon
        color="primary"
        class="icon-size material-icons-outlined cursor-pointer"
        (click)="openStepsLogs(testCase, $event)"
        (keydown)="openStepsLogs(testCase, $event)"
      >
        description
      </mat-icon>
    </td>
  </ng-container>

  <ng-container matColumnDef="report">
    <th mat-header-cell *matHeaderCellDef>Report</th>
    <td mat-cell *matCellDef="let testCase">
      <button
        color="primary"
        mat-icon-button
        aria-label="download report"
        (click)="downloadReport(testCase, $event)"
        [disabled]="testRunning && !isHistoryItem"
      >
        <mat-icon class="icon-size material-icons-outlined">
          download
        </mat-icon>
      </button>
    </td>
  </ng-container>

  <ng-container matColumnDef="expand">
    <th mat-header-cell *matHeaderCellDef aria-label="row actions">&nbsp;</th>
    <td mat-cell *matCellDef="let testSuite">
      <button
        mat-icon-button
        aria-label="expand row"
        (click)="
          expandedElement = expandedElement === testSuite ? null : testSuite;
          $event.stopPropagation()
        "
      >
        @if (expandedElement === testSuite) {
          <mat-icon>keyboard_arrow_up</mat-icon>
        } @else {
          <mat-icon>keyboard_arrow_down</mat-icon>
        }
      </button>
    </td>
  </ng-container>

  <!-- Expanded Content Column - The detail row is made up of this one column that spans across all columns -->
  <ng-container matColumnDef="expandedDetail">
    <td
      mat-cell
      *matCellDef="let testCase"
      [attr.colspan]="testCaseColumnsWithExpand.length"
    >
      <div
        class="execution-test-case-detail"
        [@detailExpand]="
          testCase === expandedElement ? 'expanded' : 'collapsed'
        "
      >
        @if (!testCase.endDate) {
          <div
            class="d-flex flex-column align-items-center justify-content-between"
          >
            <mat-icon>content_paste_search</mat-icon>
            <pre class="execution-test-case-steps">
The step by step report will be displayed here, once each step has finished.
For a live preview of the process, access the <span (click)="openStepsLogs(testCase, $event)" (keydown)="openStepsLogs(testCase, $event)" class="logs-btn text-primary cursor-pointer" >logs</span>.
</pre>
          </div>
        } @else {
          <div class="d-flex w-100">
            <div class="d-flex flex-column w-33 justify-content-evenly">
              <h4>Test step</h4>
              @for (step of testCase.stepsList; track step; let i = $index) {
                <p class="mt-0">Step {{ i + 1 }}</p>
              }
            </div>

            <div class="d-flex flex-column w-33 justify-content-evenly">
              <h4>Description</h4>
              @for (step of testCase.stepsList; track step) {
                <p class="mt-0">
                  {{ step.description }}
                </p>
              }
            </div>

            <div class="d-flex flex-column w-33 justify-content-evenly">
              <h4>Status</h4>
              @for (step of testCase.stepsList; track step) {
                <p class="mt-0">
                  @if ((step.result | uppercase) === "SUCCESS") {
                    <mat-icon class="check-circle-icon text-success">
                      check_circle
                    </mat-icon>
                  } @else if ((step.result | uppercase) === "FAILURE") {
                    <mat-icon class="cancel-icon text-error">cancel</mat-icon>
                  }
                </p>
              }
            </div>
          </div>
        }
      </div>
    </td>
  </ng-container>

  <tr mat-header-row *matHeaderRowDef="testCaseColumnsWithExpand"></tr>
  <tr
    mat-row
    *matRowDef="let testCase; columns: testCaseColumnsWithExpand"
    class="execution-test-case-row"
    [class.expanded-row]="expandedElement === testCase"
    (click)="expandedElement = expandedElement === testCase ? null : testCase"
    (keydown)="expandedElement = expandedElement === testCase ? null : testCase"
  ></tr>

  <tr
    mat-row
    *matRowDef="let row; columns: ['expandedDetail']"
    class="detail-row"
  ></tr>
</table>
